/* deck.cpp
 * Yunita Winata
 * c203101
 */
/* Implementation of the Deck class
 * For more info see the header file
 */

#include <stdlib.h>
#include"Deck.h"

Deck::Deck()
{
	position = 0;
	for(int i=0;i<52;i++)
		cdeck[i] = new Card(i+1);
}

Deck::~Deck()
{
	for(int i=0;i<52;i++)
		delete cdeck[i];
}

Card Deck::Deal()
{
	Card * returnvalue = cdeck[position];
	position=position+1;
	if (position==52)
		position=0;
	return *returnvalue;
}

int Deck::CardsLeft()
{
	return 52-position;
}

int Deck::Shuffle()
{
	for(int i=1; i<52; i++)
	{
		Card * temp = cdeck[i];
		int j = rand() % (i+1);
		cdeck[i] = cdeck[j];
		cdeck[j]=temp;
	}

	position = 0;  //after reshuffling we assume that new game will be started.

	return 0;
}

int Deck::ReattachDealedCards()
{
	if (position > 0)
	{
		int i;
		Card * temparray[52];
		for(i=0;i<position;i++)	// copy the used cards to the temp array
			temparray[i]=cdeck[i];
		for(i=position;i<52;i++) // move the remaining cards ahead
			cdeck[i-position]=cdeck[i];
		for(i=0;i<position;i++) // add the used cards at the back
			cdeck[52+i-position]=temparray[i];
	}

	position=0;

	return 0;
}