/* game.cpp
 * Yunita Winata
 * c203101
 */
/* This is the implementation of the Game class
 * For more info see the header file
 */
#include <stdio.h>
#include "game.h"

Game::Game()
{
}

void Game::MainMenu()
{
	int choice;
	int firststart=1; // 1=True; 0=False
	money=500;

	Deck * gdeck;
	gdeck = new Deck;

	while (choice!=5)
	{
		if (firststart==1)
		{
			choice=3;
			firststart=0;
		}
		else
		{
			cout<<"Your Money:$"<<money;
			cout<<"\nMain Menu:\n";
			cout<<"1. Shuffle Deck\n";
			if (money>0) //Can play only if player has money
			{	
				cout<<"2. Deal a hand\n";
			}
			cout<<"3. See Rules\n";
			cout<<"4. Restart the game\n";
			cout<<"5. Exit\n\n";
			cout<<"Enter Selection: ";
			cin>>choice;
		}

		switch (choice)
		{
			case 1:
				gdeck->Shuffle();
				cout<<"\nDeck Shuffled!\n";
				break;
			case 2:
				if (money>0)
				{
					cout<<"\n";
					(*gdeck).ReattachDealedCards();
					GameMenu(gdeck);
				}
				break;
			case 3:
				cout<<"***********************************\n";
				cout<<" WELCOME TO MY CASINO!\n";
				cout<<"\tHere are the Rules:\n";
				cout<<"\t-------------------\n";
				cout<<"% Dealer stands on soft 17\n";
				cout<<"% Only one deck of cards is used\n";
				cout<<"% Double Down allowed\n";
				cout<<"% No splits allowed currently (sorry!)\n";
				cout<<"% No doubles after split\n";
				cout<<"% No surrender options\n";
				cout<<"***********************************\n";
				break;
			case 4:
				delete gdeck;
				gdeck = new Deck; //New deck of cards
				money=500; //New money
				cout<<"\n\nThe game had been restarted !\n\n";
				break;
			case 5:
				delete gdeck;
				break;
			default:
				cout<<"\nInvalid selection!!!\n";
				break;
		}
	}
}

void Game::GameMenu(Deck * gdeck)
{
	int choice;
	int restart=0; //0=False, 1=TRUE; TRUE means the game need to be restarted

	PutBet();

	DealNewHand(gdeck);

	while (choice!=5)
	{
		if (money<0)
		{
			cout<<"YOU ARE BROKE!!!!!!!!!!!\nPLEASE RESTART THE GAME";
			return; //If player is broke then it will send player back to main menu
		}
		if (restart==0)  //Print out money information
			cout<<"\nYour Money:$"<<money<<" Money on the table:$"<<bet<<"\n";

		cout<<"\nGame Menu:\n";

		if (restart==0)
		{
			cout<<"1. Display my hand\n";
			cout<<"2. Hit me\n";
			cout<<"3. Stand\n";
		}
		else
		{
			cout<<"4. Deal new hand\n";
			cout<<"5. Back to Main Menu\n\n";
			cout<<"Enter Selection: ";
		}
		cin>>choice;

		switch (choice)
		{
			case 1:
				if (restart==0)
					DisplayCards(1);
				break;
			case 2:
				if (restart==0)
				{
					AddCard(1,gdeck);
					cout<<"\nCard Added\n";
					DisplayCards(1);
				}
				break;
			case 3:
				if (restart==0)
					restart=DealerMoves(gdeck);
				break;
			case 4:
				// can not restart if game is in progress
				if (restart!=0)
				{
					restart=0;
					bet=0; //Reset bet money to 0
					cout<<"\nRestart\n\n";
					(*gdeck).ReattachDealedCards();
					PutBet();
					DealNewHand(gdeck);
				}
				break;
			case 5:
				// can't exit if game is in progress
				if (restart==0)
					choice=0;
				break;
			default:
				cout<<"\nInvalid selection!!!\n";
				break;
		}

		//This section is used for checkin if player card exceed 21
		if ((sumvalue[1]>21) && (sumvalue[1]<99) && (restart==0))
		{
			if (aces[1]==0)
			{
				cout<<"You Lose!!!! You have " <<sumvalue[1] <<"\n\n";
				cout<<"Your money: $"<<money<<"\n";
				restart=1;
			}
			else
			{
				sumvalue[1]=sumvalue[1]-10;
				aces[1]=aces[1]-1;
			}
		}
	}
}

void Game::DealNewHand(Deck * gdeck)
{
	// clear the variables from the old game
	for (int i=0;i<2;i++)
	{
		aces[i]=0;
		sumvalue[i]=0;
		numcards[i]=0;
	}

	// give two cards to the player and one to the dealer
	AddCard(1,gdeck);
	AddCard(0,gdeck);
	AddCard(1,gdeck);
	DisplayCards(1);
}

void Game::AddCard(int who,Deck * gdeck)
{
	Card temp(1);

	temp=gdeck->Deal();

	playercards[who][numcards[who]][0]=temp.CardID();
	playercards[who][numcards[who]][1]=temp.Set();

	numcards[who]=numcards[who]+1;

	if (temp.Value()==11)
	{
		aces[who]=aces[who]+1;
	}

	sumvalue[who]=sumvalue[who]+temp.Value();

	// if Black Jack the Value is 99!!!
	if ((sumvalue[who]==21) && (numcards[who]==2))
		sumvalue[who]=99;
}

void Game::DisplayCard(int who,int num)
{
	if ((playercards[who][num][0]>1) && (playercards[who][num][0]<11))
	// if bettween 2 and 10 display just the number
		cout<<"\t"<<playercards[who][num][0]<<" of ";
	else
	// some logic to printout the names of the picture cards  
	switch (playercards[who][num][0])
	{
		case 1:
			cout<<"\tAce of ";
			break;
		case 11:
			cout<<"\tJack of ";
			break;
		case 12:
			cout<<"\tQueen of ";
			break;
		case 0:
			cout<<"\tKing of ";
			break;
		default:
			break;
	}

	switch (playercards[who][num][1])
	{
		case 1:
			cout<<"Spades\n";
			break;
		case 2:
			cout<<"Hearts\n";
			break;
		case 3:
			cout<<"Clubs\n";
			break;
		case 4:
			cout<<"Diamonds\n";
			break;
		default:
			break;
	}

}


void Game::DisplayCards(int who)
{
	char confirmdouble; //(y/n) y= call DoubleBet(), n do nothing
	
	//Double down option only during the first deal
	if (numcards[who]==2 && who==1)
	{
		cout<<"Player "<<who<<" First Card: ";
		DisplayCard(who,0);
		cout<<"Dealer's first card: ";
		DisplayCard(0, 0);

		//if players has money to double
		if (money>=bet)
			//Check if player want to Double down
			while (confirmdouble!='y' && confirmdouble!='n')
			{
				cout<<"Do you want to Double your bet (y/n)?";
				cin>>confirmdouble;
				if (confirmdouble=='y')
					DoubleBet();
			}
		else
			cout<<"You don't have enough money to double!\n";


		cout<<"Player "<<who<<" Second Card: ";
		DisplayCard(who,1);
	}
	//No double down option
	else
	{
		cout<<"Player " << who << " has:\n";
		for (int i=0;i<numcards[who];i++)
		{
			DisplayCard(who, i);
		}
	}

	return;
}

int Game::DealerMoves(Deck * gdeck)
{
	while(sumvalue[0]<17)
	{
		AddCard(0,gdeck);
		cout<<"Dealer draws another card:";
		DisplayCard(0, (numcards[0]-1));

		if ((sumvalue[0]>21) && (sumvalue[0]<99))
		{
			if (aces[0]==0)
			{
				if (sumvalue[1]==21)
					money=money+bet*3; //Add bet money + win money *2 (because black jack)
				else
					money=money+bet*2; //Add bet money + win money to total money
				cout<<"\nYou Win!!! Dealer exceeded 21.\n";
				cout<<"Your money: $"<<money<<"\n";
				return 1;
			}
			else
			{
				sumvalue[0]=sumvalue[0]-10;
				aces[0]=aces[0]-1;
			}
		}
	}
	// after dealer is done - he stands
	cout<<"Dealer stands\n";


	// display final result
	if (sumvalue[1]==99)
		cout<<"You have: Black Jack";
	else
		cout<<"You have:"<<sumvalue[1];

	if (sumvalue[0]==99)
		cout<<"\tDealer has: Black Jack\t";
	else
		cout<<"\tDealer has:"<<sumvalue[0]<<"\t";


	if ((sumvalue[0]==99) && (sumvalue[1]==99))
	{
		money=money+bet; // Tie - Return bet
		cout<<"Tie!!!!\n";
	}
	else
	{
		if (sumvalue[0]<sumvalue[1])
		{
			if (sumvalue[1]==99)
				money=money+bet*3; //Add bet money + win money *2 (because black jack)
			else
				money=money+bet*2; //Add bet money + win money to total money

			cout<<"You win!!!!\n";
		}
		else
			cout<<"You Lose!!!!\n";
	}

	cout<<"Your money: $"<<money<<"\n";

	return 1;
}

//All variables in this fucntions are global private variables
void Game::PutBet()
{
	bet=0;

	while (bet==0)
	{
		cout<<"How much money you want to put? ";
		cin>>bet;
		if (money>=bet)
			money=money-bet;
		else
		{
			cout<<"You don't have that much money\n";
			bet=0;
		}
	}
}

void Game::DoubleBet()
{
	money=money-bet;
	bet=bet*2;
}