/* ttt.cpp
 * Tic Tac Toe
 * Yunita Winata
 * c203101
 */

#include <iostream.h>
#define TIC 4 //representation of X
#define TAC 1 //representation of O

void explanation ();
void initialize (int[3][3]);
void display (int[3][3]);
int player (int[3][3]);
int computer (int[3][3]);
void result (int);
int possibility (int[3][3], int*, int*, int);

int main ()
{
	int array[3][3], check = 0, counter;
	char prompt = 'Y';

	explanation ();
	cout << "Enter 'Y' for yes, other letters for no.\n";
	cout << "Do you want to play the game? ";
	cin >> prompt;

	while (prompt == 'Y' || prompt == 'y')
	{
		initialize (array);
		check = 0;
		display (array);
		counter = 0;

		while (check == 0)
		{
			check = player (array);
			if (check>0)
			{
				display (array);
				result (2);
			}
			if (check == 0)
			{
				check = computer (array);
				display (array);
				if (check>0)
					result (1);
			}
			counter++;
			if (counter == 4 && check==0)
			{
				cout << "End of game.\n";
				cout << "It's a draw!\n\n";
				check = 1;
			}
		}

		cout << "Enter 'Y' for yes, other letters for no.\n";
		cout << "Do you want to play the game again? ";
		cin >> prompt;
	}
	if (prompt != 'Y' || prompt != 'y')
		cout << "Thank you for playing Tic Tac Toe!\n";

	return (0);
}

void explanation ()
{
	cout << "\nWelcome to my TIC TAC TOE program!\n\n";
	cout << "This program assume the player is X and computer\n"
		<< "is O\n";
	cout << "When you are already in the game, please enter\n"
		<< "numbers only. Do not enter other letters.\n"
		<< "This program does not counter input error during\n"
		<< "the game, except numerical error.\n\n";
	cout << "Remember this space number for your move:\n"
		<< " 1 | 2 | 3\n"
		<< "---------\n"
		<< " 4 | 5 | 6\n"
		<< "---------\n"
		<< " 7 | 8 | 9\n\n";
}

void initialize (int array[3][3])
{
	int r, c;
	for (r = 0; r < 3; r++)
		for (c = 0; c <3; c ++)
			array[r][c] = 0;
}

//This function is to display the TicTacToe board
void display (int array[3][3])
{
	int r, c;

	cout << "\n";
	for (r = 0; r <3; r++)
	{
		for (c = 0; c < 3; c++)
		{
			if (array[r][c] == 0)
			{
				cout << " ";
				if (c < 2)
					cout << " | ";
			}
			if (array[r][c] == TAC)
			{
				cout << "O";
				if (c < 2)
					cout << " | ";
			}
			if (array[r][c] == TIC)
			{
				cout << "X";
				if (c < 2)
					cout << " | ";
			}
			if (array[r][c] != 0 && array[r][c] != TAC && 
					array[r][c] != TIC)
				cout << "Error 1\n";
		}
		if (r < 2)
			cout << "\n---------\n";
	}
	cout << "\n\n";
}

//This is player function that deals with all the moves
//player can take, will use possibility function to
//calculate the player score, so that the computer can
//make its move
int player (int array[3][3])
{
	int convert (int, int*, int*);
	int temp, r = 0, c = 0, check;

	cout << "Please enter your move > ";
	cin >> temp;

	convert (temp, &r, &c);
	while (temp <= 0 || temp >= 10)
	{
		cout << "You have entered invalid move!\n";
		cout << "Please enter your move again > ";
		cin >> temp;
		convert (temp, &r, &c);
	}
	while (array[r][c] == TAC)
	{
		cout << "That spot had been taken by the computer\n";
		cout << "Please enter your move again > ";
		cin >> temp;
		convert (temp, &r, &c);
	}
	while (array[r][c] == TIC)
	{
		cout << "You had taken that spot\n";
		cout << "Please enter your move again > ";
		cin >> temp;
		convert (temp, &r, &c);
	}
	
	check = possibility (array, &r, &c, TIC);
	if (array[r][c] == 0)
		array[r][c] = TIC;
	if (array[r][c] != 0 && array[r][c] != TAC && array[r][c] != TIC)
		cout << "Error 2\n";
	
	return (check);
}

//This function is to convert the input from player
//of his/her move into computer representation of that
//move as 2-d matrixes (r & c)
int convert (int temp, int *r, int *c)
{
	if (temp > 0 && temp < 4)
	{
		*r = 0;
		*c = temp - 1;
	}
	if (temp > 3 && temp < 7)
	{
		*r = 1;
		*c = temp - 4;
	}
	if (temp > 6 && temp < 10)
	{
		*r = 2;
		*c = temp - 7;
	}

	return (*r, *c);
}

//This is the function that deals with computer's move
//it has 4 possible way to move: the priority is as listed
//1. to win the game
//2. to block the player
//3. to implement strategy
//4. to just randomly move (usually if it was the first time
//	 the computer has to move.
//All of those functions will use possibility function
//to calculate the score and decide which move to be taken
int computer (int array[3][3])
{
	int win (int[3][3]);
	int block (int[3][3]);
	int strategy (int[3][3]);
	int random (int[3][3]);
	int check;

	check = win (array);
	if (check == 0)
	{
		check = block (array);
		if (check == 0)
		{
			check = strategy (array);
			if (check == 0)
				random (array);
		}
	}
	else
		return (check);
	return (0);
}

int win (int array[3][3])
{
	int r, c, score;

	for (r = 0; r <3; r++)
	{
		for (c = 0; c < 3; c++)
		{
			score = possibility (array, &r, &c, TAC);
			if (score > 0)
			{
				array[r][c] = TAC;
				return (1);
			}
		}
	}
	return (0);
}

int block (int array[3][3])
{
	int r, c, score,temp = 0,temp_r, temp_c;

	for (r = 0; r <3; r++)
	{
		for (c = 0; c < 3; c++)
		{
			score = possibility (array, &r, &c, TIC);
			if (score > temp)
			{
				temp_r = r;
				temp_c = c;
				temp = score;
			}
		}
	}
	if (temp > 0)
		array[temp_r][temp_c] = TAC;
	return (temp);
}

int strategy (int array[3][3])
{
	int r, c, score,temp = 0,temp_r, temp_c;

	for (r = 0; r <3; r++)
	{
		for (c = 0; c < 3; c++)
		{
			score = possibility (array, &r, &c, 0);
			if (score > temp)
			{
				temp_r = r;
				temp_c = c;
				temp = score;
			}
			if ((score==temp) && ((r==0 && c==0)||(r==0 && c==2)||
				(r==2 && c==0)||(r==2 && c==2)))
			{
				temp_r = r;
				temp_c = c;
			}
		}
	}
	if (temp > 0)
		array[temp_r][temp_c] = TAC;
	return (temp);
}

int random (int array[3][3])
{
	int r, c;

	for (r = 0; r <3; r++)
	{
		for (c = 0; c < 3; c++)
		{
			if (array[r][c] == 0)
			{
				array[r][c] = TAC;
				return (0);
			}
		}
	}
	return (0);
}

//This is the core function that was used to calculate
//the score. Called by both player and computer function
//There is no better way to understand this function
//than to go through it line by line
int possibility (int array[3][3], int *r, int *c, int x)
{
	int i, temp = 0, score = 0;
	
	if (array[*r][*c] == 0)
	{
		/* Row */
		for (i=0;i<3;i++)
		{
			if (array[*r][i] == x)
				temp++;
			else
			{
				if (array[*r][i] == 0 && i == *c)
					temp++;
			}
		}
		if (temp == 3)
			score++;
		
		/* Column */
		temp = 0;
		for (i = 0; i < 3; i++)
		{
			if (array[i][*c] == x)
				temp++;
			else
			{
				if (array[i][*c] == 0 && i == *r)
					temp++;
			}
		}
		if (temp == 3)
			score++;

		/* Horizontal \ */
		temp = 0;
		if ((*r==0 && *c==0)||(*r==2 && *c==2)||(*r==1 && *c==1))
		{
			for (i = 0; i < 3; i++)
			{
				if (array[i][i] == x)
					temp++;
				else
				{
					if (array[i][i]==0 && i==*c && i==*r)
						temp++;
				}
			}
		}
		if (temp == 3)
			score++;
		
		/* Horizontal / */
		temp = 0;
		if ((*r==0 && *c==2)||(*r==2 && *c==0)||(*r==1 && *c==1))
		{
			for (i = 0; i < 3; i++)
			{
				if (array[i][2-i] == x)
					temp++;
				else
				{
					if (array[i][2-i]==0 && i==*r && 2-i==*c)
						temp++;
				}
			}
		}
		if (temp == 3)
			score++;

		return (score);
	}
	return (0);

}

//This is the function to figure out the result of the game
//Only deal with winning or losing, the draw result is
//dealt in the main function
void result (int check)
{
	if (check == 0)
		return;
	if (check == 1)
	{
		cout << "End of game.\n";
		cout << "Computer wins!\n\n";
		return;
	}
	if (check == 2)
	{
		cout << "End of game.\n";
		cout << "Congratulations, you win!\n\n";
		return;
	}
	if (check != 0 || check != 1 || check != 2)
	{
		cout << "Error 3\n";
		return;
	}
}